/*
								+---------------------------------+
								|                                 |
								|       ***   Pyramid   ***       |
								|                                 |
								|  Copyright   -tHE SWINe- 2002  |
								|                                 |
								|            Pyramid.h            |
								|                                 |
								+---------------------------------+
*/

#ifndef __PYRAMID_INCLUDED
#define __PYRAMID_INCLUDED

struct Pyramid {
	Plane p0, p1, p2, p3; 
};

struct Polygon {
	int n_vertex_num;
	Vertex vertex[7];
};

void SetPlane(Plane *p_plane, float a1, float a2, float a3,
    float b1, float b2, float b3, float c1, float c2, float c3);

void SetFOV(float n_Width, float n_Height, float f_z_delta, Pyramid *p_pyramid);

int inline ClassifyVtxPl(Vertex *p_vertex, Plane *p_plane);

int inline ClassifyFacePl(Face *p_face, Plane *p_plane);

int inline PtInFOV(Vertex *p_vertex, Pyramid *p_pyramid);

Polygon Clip_Face(Face *p_face, Pyramid *p_pyramid);

Polygon SplitPolygon(Polygon *p_poly, Plane *p_plane);

Vertex IntersectSegmentPl(Vertex *p_v1, Vertex *p_v2, Plane *p_plane);

#endif